{% extends 'base.html.twig'%}

{% block body %}
    
	{{ include('micro-post/raw-post.html.twig', { 'post': post }) }}
	
	{% set isLiked = post.getLikedBy.contains(app.user) %}

		<div class="pt-2">
			<button id="like" class="btn btn-outline-secondary btn-sm" style="display: {% if not isLiked %}block{% else %}none{% endif %}">Like
				<span id="likes-like" class="badge badge-light">{{ post.getLikedBy.count }}</span>
			</button>

			<button id="unlike" class="btn btn-outline-danger btn-sm" style="display: {% if isLiked %}block{% else %}none{% endif %}">Unlike
				<span id="likes-unlike" class="badge badge-light">{{ post.getLikedBy.count }}</span>
			</button>

		</div>
{% endblock %} 


{% block javascripts %}

	{{ parent() }}

	<script>
		var	likeButton = document.getElementById('like');
		var	unlikeButton = document.getElementById('unlike');

		addOnClick(
			likeButton,
			unlikeButton,
			document.getElementById('likes-unlike'),
			'{{ path('likes_like', {'id': post.id}) }}'
		);

		addOnClick(
			unlikeButton,
			likeButton,
			document.getElementById('likes-like'),
			'{{ path('likes_unlike', {'id': post.id}) }}'
		);

		function switchButtons(button, oppositeButton) {
			button.style.display = 'none';
			oppositeButton.style.display = 'block';
		}

		function addOnClick(button, oppositeButton, likeCount, path) {
			button.addEventListener('click', function(event) {
				{% if not app.user %}
					return window.location.replace('{{ path('user_register')}}')
				{% endif %}
				button.disabled = true;
				fetch(path, {'credentials': 'include'}).then(function (response) {
					response.json().then(function (json) {
						likeCount.innerText = json.count;
						switchButtons(button, oppositeButton);
					})
				}).catch(function () {
					switchButtons(button,oppositeButton);
				});

				event.preventDefault();
			});

		}
	</script>
    
{% endblock %}